 Dim xlsApp, xlsBook, xlsSheet, xlsFileName
'ûSheet
Function SetActiveSheet( sheetName )
    Set xlsSheet = xlsBook.Worksheets(sheetName)
    xlsSheet.Activate
End Function

Function SetActiveSheetByIndex( sheetindex )
    Set xlsSheet = xlsBook.Worksheets(sheetindex)
    xlsSheet.Activate
End Function

'
Function CopySheet(srcSheetName, tagSheetName)
   Dim xlsSheet0, xlsSheet1
   Set xlsSheet0 = xlsBook.Worksheets(srcSheetName)
   xlsSheet0.Select
   xlsSheet0.Copy xlsSheet0
   Set xlsSheet1 = xlsBook.ActiveSheet
   xlsSheet1.Select
   xlsSheet1.Name = tagSheetName
End Function

'ɾ
Function DeleteSheet( sheetName )
   Dim xlsSheet0
   Set xlsSheet0 = xlsBook.Worksheets(sheetName)
   xlsSheet0.Select
   xlsSheet0.Delete
End Function

'
Function CopySheetTable( beginRow, count, pageRowCount )
    For i=0 To count-1
       xlsSheet.Rows( beginRow & ":" & (beginRow+pageRowCount-1) ).Select
       xlsApp.Selection.Copy
       row = (i+1)*pageRowCount+beginRow
       rows = row & ":" & row
	   xlsSheet.Rows(rows).Select
       xlsSheet.Paste   
    Next
End Function

'ɾ
Function DelSheetTable( beginRow, pageRowCount )
       xlsSheet.Rows( beginRow & ":" & (beginRow+pageRowCount-1) ).Select
       xlsApp.Selection.Delete   
 End Function

'䵥Ԫ
Function SetCellValue(row, col, value)
	    xlsSheet.Cells(row, col) = value
End Function

'ϲԪʽ
Function MergeCell(row, beginCol, EndCol)
       xlsSheet.Range(xlsSheet.Cells(row, beginCol), xlsSheet.Cells(row, EndCol)).Merge
End Function
Function OpenBar(byval barname, range)
   SSProcess.EpsProgressCreate range,barname
   SSProcess.EpsProgressSetStep  1
End Function
Function CloseBar()
      SSProcess.EpsProgressDelete  
End Function
Function RollBar(barname,dispmsg)
    SSProcess.EpsProgressStepIt   
   SSProcess.EpsProgressUpdateMsg  barname  & dispmsg
End Function

'ַֽ
Function ScanString(ByVal str, ByVal sep, ByRef strs(), ByRef count)
    Dim sepidx1, sepidx2,  strtemp
    count  = 0
    sepidx1 = 1
    sepidx2 = InStr(sepidx1 , str, sep, 1)
	  While (sepidx2 > 0)
       strs(count) = Mid( str, sepidx1, sepidx2-sepidx1)
        sepidx1 = sepidx2+1
       sepidx2 = InStr(sepidx1, str, sep, 1)
       count = count + 1
    Wend
    strs(count) = Mid( str, sepidx1, Len(str)+1-sepidx1)
    count = count + 1
End Function

'ʼXLS
Function InitXLS()
  	  Set xlsApp = CreateObject("Excel.Application")
     xlsApp.Application.Visible = True
     xlsApp.DisplayAlerts   =   False   
     templateXlsName = SSProcess.GetSysPathName(0) & "\templates\ɽлģ_500\ַʾ.xls"
     Set xlsBook = xlsApp.Workbooks.Add( templateXlsName )
End Function

'ͷXLS
Function ReleaseXLS()
      xlsBook.SaveAs xlsFileName
       Set  xlsSheet = nothing
      Set xlsBook = nothing
      xlsApp.Quit
      Set xlsApp = nothing
End Function

'Ƿ贴ҳ
Function newpage( byref curRowNO, byref curPageNo, pageRowCount, djh, qlr, guid)
     If curRowNO>pageRowCount-9 Or curRowNO =0 Then
			select case curPageNo
			 case "0"
	          curPageNo = curPageNo + 1
				 CopySheetTable  (curPageNo-1)*pageRowCount+9, 1, pageRowCount-8
				 curRowNO = 3
				 'ڵر
				 SetCellValue (curPageNo-1)*pageRowCount+curRowNO, 1, "ڵش:" & djh
				 'Ȩ           
				 SetCellValue (curPageNo-1)*pageRowCount+curRowNO, 8,"Ȩ:" & qlr
				 curRowNO =  curRowNO +1
				 'FeatureGUID
				 SetCellValue (curPageNo-1)*pageRowCount+curRowNO, 1,"FeatureGUID:" & guid
				 curRowNO =  curRowNO +5
				 newpage = 1
			 case "1"
					if curRowNO>pageRowCount-1 then
						curPageNo = curPageNo + 1
						CopySheetTable  (curPageNo-1)*pageRowCount+1, 1, pageRowCount-8
						curRowNO = 1
					   newpage = 1
					end if
			 case else
			   curPageNo = curPageNo + 1
				CopySheetTable  (curPageNo-1)*pageRowCount-(curPageNo-2)*8 +1, 1, pageRowCount-8
				curRowNO = 1
				newpage = 1
			end select
     Else
         newpage = 0
     End If
End Function


Sub OnClick()
      'ȡϵͳѡ񼯶
      SSProcess.ClearSelection  
      SSProcess.UpdateSysSelection "0"
      geoCount =   SSProcess.GetSelGeoCount()
      Dim zdids(10000), zdcount
      zdcount=0
      For i=0 To geoCount-1
         geoCode = SSProcess.GetSelGeoValue (i, "SSObj_Code" )
            if geoCode="6801053" Or geoCode="6801063" Or geoCode="6801073" Or geoCode="6801051" Or geoCode="7366" Then
               zdids(zdcount) = CLng(SSProcess.GetSelGeoValue (i, "SSObj_ID" ))
				   zdcount=zdcount+1
            End If
      Next

      If zdcount=0 Then
         msgbox "ѡҪڵ!"
          Exit Sub
      End If

 'ѡļ·
      pathname = SSProcess.SelectPathName
      If pathname = "" Then
         Exit Sub
      End If

      For i=0 To zdcount-1
         geoID =  zdids(i)
         djh = SSProcess.GetObjectAttr (geoID, "[ZDDM]" )
         qlr = SSProcess.GetObjectAttr (geoID, "[QLR]" )
         guid = SSProcess.GetObjectAttr (geoID, "[FeatureGUID]" )
         pointcount = SSProcess.GetObjectAttr (geoID, "SSObj_PointCount" )
         xlsFileName = pathname &  djh & ".xls"

		'ʼXLS
			InitXLS
         SetActiveSheetByIndex 1

         curRowNO=0
         curPageNo=0
         pageRowCount=47
         Dim x00,y00, x0,y0,x1,y1,pidx,pidx00, pointindex,name,ptype
         pointindex = 0
         SSProcess.GetObjectPoint geoID, pointindex, x0,  y0,  z,  ptype,  name
         x00 = x0
         y00 = y0
         pidx00 = 1
         pidx = 1
         newpage  curRowNO,  curPageNo, pageRowCount, djh, qlr, guid 
 			SetCellValue curRowNO, 1,  pidx 

         For j=1 To pointcount-1
            SSProcess.GetObjectPoint geoID, j, x1,  y1,  z,  ptype,  name
               dist = sqr(   (x1-x0)*(x1-x0) + (y1-y0)*(y1-y0) )
				   select case curPageNo
					   case"1"
							if curRowNO=9 then
								SetCellValue curRowNO, 7,  CStr(dist)
							else
								SetCellValue curRowNO+1, 7,  CStr(dist)
							end if
						case else
							if  curRowNO=1 then
								SetCellValue (curPageNo-1)*pageRowCount-(curPageNo-2)*8 + curRowNO, 7,  CStr(dist)
							else
									SetCellValue (curPageNo-1)*pageRowCount-(curPageNo-2)*8 + curRowNO+1, 7,  CStr(dist) 
							end if
						end select
            curRowNO = curRowNO+2
	         bCreate = newpage (curRowNO,  curPageNo, pageRowCount, djh, qlr, guid )
            If bCreate =1Then 
					SetCellValue (curPageNo-1)*pageRowCount-(curPageNo-2)*8 +curRowNO, 1,  pidx
					j= j-1
            Else 
               pidx = pidx+1
				 'պϵ
					if abs(x1-x00)<0.001 And abs(y1-y00)<0.001 Then
						select case curPageNo
							case "1"
								SetCellValue curRowNO, 1,  pidx00
							case else
								SetCellValue (curPageNo-1)*pageRowCount-(curPageNo-2)*8 +curRowNO, 1,  pidx00
						end select
						   if j<pointcount-1 Then
								SSProcess.GetObjectPoint geoID, j+1, x0,  y0,  z,  ptype,  name
								x00 = x0
								y00 = y0
								'pidx =pidx +1
								pidx00  =  pidx 
								curRowNO = curRowNO+2      
								page = newpage (curRowNO,  curPageNo, pageRowCount, djh, qlr, guid)
								If page =1 Then 
									SetCellValue (curPageNo-1)*pageRowCount-(curPageNo-2)*8 +curRowNO, 1,  pidx
									j= j-1
								Else 
									select case curPageNo
										case "1"
											SetCellValue curRowNO, 1,  pidx
										case else
											SetCellValue (curPageNo-1)*pageRowCount-(curPageNo-2)*8 +curRowNO, 1,  pidx
									end select
								  j = j+1
								End if
							end If    
					else
						select case curPageNo
							case "1"
								SetCellValue curRowNO, 1,  pidx
								x0 = x1
								y0 = y1
							case else
								SetCellValue (curPageNo-1)*pageRowCount-(curPageNo-2)*8 +curRowNO, 1,  pidx
								x0 = x1
								y0 = y1
						end select
					end If
            End If
         Next
         'ɾһձ
         DelSheetTable curPageNo*39+9, pageRowCount
	      'ͷXLS
		  ReleaseXLS
		Next
     msgbox "" & zdcount & "ڽַ"
End Sub
